var pc = require("pace-converter");
var _ = require('underscore');
var isNumeric = require('isnumeric');

var _trainingPaces=require(__dirname + '/data/vdot-training.json');
var hrTables = Object.keys(_trainingPaces[0]);

module.exports = {
	getVdot:function(kph,hr,maxhr){
		return this.getVdotAdjusted(kph,hr,maxhr,15,0,0);
	},

	getVdotAdjusted:function(kph,hr,maxhr,temp,startHr,warmupTime){
//		var walkHr=94;

//		var walkHrAdjustmentFactor = 1+ (1- (walkHr/startHr))/1.4;
//		if(walkHrAdjustmentFactor <0 || startHr ==0 || startHr>115 || warmupTime<3){//alex fix 115
			//if there is low HR factor I don't penalize
//			walkHrAdjustmentFactor=1;//no affect
//		}
//		var tempFactor = this.getTempFactor(warmupTime,kph,temp);
			//console.log('temp factor ' + temp +' - ' +tempFactor/kph)
//		kph = kph + tempFactor;


		var hrrPercent=Math.round((hr/maxhr)*100);

		if (!isNumeric(hrrPercent) || !isNumeric(kph) ||  hrrPercent<60 || hrrPercent>90) return -1;


		if(hrrPercent<65){
//		   return Math.round(this.getVdotCalc(hrrPercent,kph) * walkHrAdjustmentFactor*100)/100;
		   return Math.round(this.getVdotCalc(hrrPercent,kph) *100)/100;
		}
		var speed=kph;

		var lowerHr = this.getLower(hrrPercent);
		var upperHr = this.getUpper(hrrPercent);

		var percentAbove = (hrrPercent-lowerHr)/5;

		var range = this.getVdotRange(lowerHr,upperHr,kph);

		if (range.length<2) {
//		   return Math.round(this.getVdotCalc(hrrPercent,kph) * walkHrAdjustmentFactor*100)/100;
		   return Math.round(this.getVdotCalc(hrrPercent,kph) *100)/100;
		}

		var lowerSpeed1=pc.convert(range[0][lowerHr],'minkm').kmh;
		var upperSpeed1=pc.convert(range[0][upperHr],'minkm').kmh;
		var difference1 = upperSpeed1 - lowerSpeed1;
		var addIt1=difference1*percentAbove;
		var final1=lowerSpeed1+addIt1;
		var lowerSpeed2=pc.convert(range[1][lowerHr],'minkm').kmh;
		var upperSpeed2=pc.convert(range[1][upperHr],'minkm').kmh;
		var difference2 = upperSpeed2 - lowerSpeed2; //.5
		var addIt2=difference2*percentAbove;//.1005
		var range2AtHrSpeed=lowerSpeed2+addIt2;//7.74
		var finalDif=range2AtHrSpeed-speed;//.1004
		var vdotPercent = (finalDif/difference2); //.20
		var vdot=parseInt(range[1].vdot)-vdotPercent;

//		vdot = vdot * walkHrAdjustmentFactor;

		return Math.round(vdot*10)/10;
	},

	getTempFactor(warmupTime,kph,temp){
		if (temp==0) return 0;

		var tempFactor = 0,tempFactorAdd=0;
		var warmUpFactor = (warmupTime*.08)// 12 = 5%
		var fTemp =parseFloat(temp);
        if (fTemp>28){
            tempFactor = .25;
            tempFactorAdd = .2;
        }else if (fTemp>26){
            tempFactor = .17;
            tempFactorAdd = .2;
        }else if (fTemp>24){
            tempFactor = .13;
            tempFactorAdd = .1;
        }else if (fTemp>22){
            tempFactor = .09;
            tempFactorAdd = .15;
        }else if (fTemp>20){
            tempFactor = .05;
            tempFactorAdd = .25;
        }else if (fTemp>18){
            tempFactor = .03;
            tempFactorAdd = .1;
        }
        var warmUpAdjustedTempFactor = Math.round(tempFactor*warmUpFactor*1000)/1000;
        //console.log(warmUpAdjustedTempFactor*100 +'%');
        var finalAdjustment = kph* warmUpAdjustedTempFactor + tempFactorAdd;
        return parseFloat(finalAdjustment);
	},


	getVdotCalc(hrrPercent,kph){
		var vdotOut = (kph/(hrrPercent/100)) *2.8
		return vdotOut;
	},
	
	getVdotRange(lowerHr,upperHr,kph){
		var out = [];

		var vdotLower=_.find(_trainingPaces,function(obj){
			var lowerPace=obj[lowerHr.toString()];
			var upperPace=obj[upperHr.toString()];
			var lowerSpeed = pc.convert(lowerPace,'minkm').kmh;
			var upperSpeed = pc.convert(upperPace,'minkm').kmh;
			return (kph>=lowerSpeed && kph<=upperSpeed);
		});

		if (!this.isObject(vdotLower)){
			return out;
		}

		out.push(vdotLower);
		if (vdotLower.vdot=="80"){
			return out;
		}
		var vdotNext = (vdotLower.vdot+1).toString();
		var vdotUpper=_.find(_trainingPaces,function(obj){
			return (obj.vdot==vdotNext);
		});
		out.push(vdotUpper);
		return out;
	},

	isObject(val) {
	    if (val === null) { return false;}
	    return ( (typeof val === 'function') || (typeof val === 'object') );
	},

	getLower(hrrPercentIn){
		for (var i = hrTables.length - 1; i >= 0; i--) {
			var value = hrTables[i];
			if (value !='vdot' && value<=hrrPercentIn){
				return value;
			}
		}
		return 'n/a';
	},

	getUpper(hrrPercentIn){
		for(var i in hrTables){
			var value = hrTables[i];
			if (value !='vdot' && value>=hrrPercentIn){
				if (hrrPercentIn==value){
					value=(hrrPercentIn+5).toString();
				};
				return value;
			}
		}
		return 'n/a';
	}
}
